<script setup>

    const props = defineProps({
        uid: {
            type: String,
            required: true
        },
        name: {
            type: String,
            required: true
        },
        is_main: {
            type: Boolean,
            default: false
        },
        taille: {
            type: Number,
            default: NaN
        }
    })

    const dimensionCSS = computed (() => {
        let value ='';
        const lettreWidth=9;
        const lettreHeight=24;

        if (Number.isInteger(props.taille)){
            value=' max-width: '+(props.taille*lettreWidth+16+lettreWidth+((props.name.length>props.taille)?3*lettreWidth:0))+'px; max-height: '+lettreHeight+'px'
        }

        return value;
    });

    const image_src = computed(() => {
        return (props.is_main) ? "/images/white_cross.svg" : "/images/orange_cross.svg";
    });
    const font_details = computed(() => {
        return (props.is_main) ? "bg-las-orange text-white" : "bg-white text-black";
    });

    const textAfficher = computed (() => {
        let value=props.name;

        if (Number.isInteger(props.taille)){
            if (props.name.length>props.taille){
                value=props.name.substring(0,props.taille)+"...";
            }
        }

        return value;
    });

    const tooltipClass = computed (() => {
        if (Number.isInteger(props.taille)){
            if (props.name.length>props.taille){
                return " relative before:absolute before:top-3 before:left-6 before:opacity-0 before:content-[attr(tooltip-data)] before:bg-white before:text-black before:text-nowrap before:text-sm before:border before:border-slate-200 before:rounded-md before:z-5 hover:before:opacity-100";
            }
        }

        return "";
    });

    const emit = defineEmits(['remove', 'main']);

    function remove() {
        emit('remove', props.uid);
    }

    function main() {
        emit('main', props.uid);
    }
</script>

<template>
    <div :tooltip-data="name" :style="dimensionCSS" :class="` flex flex-row space-x-2 w-fit px-2 rounded-[16px] ${font_details} text-center shadow-las ${tooltipClass} hover:cursor-pointer`">
        <img :src="`${image_src}`" width="15px" height="15px" @click="remove()" >
        <span @click="main()">{{ textAfficher }}</span>
    </div>
</template>